function [u, ord] = hrand(x, t, U, disc)
% random actions
% x and t arguments are ignored (x is used in init mode)

% process 'init' mode
if ischar(x) && strcmp(x, 'init'),
    u = [];   % the initial state of the controller
    ord = 0;   % the order of the controller
    return;
end;

% output a random action
if disc,    % U is a set of discrete actions, each action on a column
    u = U(:, unidrnd(size(U, 2)));
else        % U is a matrix of intervals for each action variable, each interval on a row
    u = U(:, 1) + (U(:, 2) - U(:, 1)) .* rand(size(U, 1), 1);
end;
