function xseq = mararm_simagent(m, x, useq, K)
%  Simulate a single agent in a multi-robot-arm system.
%  [XFIN] = MALINEAR_SIMAGENT(M, X, USEQ, K)
%  Parameters:
%   M           - the model specification
%   X           - current state, x(k) of the agent
%   USEQ        - command sequence u(k), ..., u(k+K-1) for the agent: matrix of flat vectors
%  Returns:
%   XSEQ        - resulting sequence of states, x(k), x(k+1), ..., x(k+K)

xseq = zeros(m.p(1), K+1); xseq(:, 1) = x; 
for k = 1:K, xseq(:, k+1) = rarm_discretestep(m, xseq(:, k), useq(:, k)); end;

end