clear all;

imgdir = 'D:\Work\tex\papers\fuzzieee08\img\';

% what = 'cons rew';        % use for all plots
what = 'cons';

if strfind(what, 'rew'),
    cfg.rew = 'lqr';
    cfg.savedir = imgdir;
    cfg.savefig = 'lqr_rew';
    cfg.plottarget = 'latex';
    cfg.slice = [NaN, NaN, 5];
    cfg.zlim = [-80 20];
    
    dc_plot(cfg);
    
    cfg.rew = 'shaping';
    cfg.savefig = 'shaping_rew';

    dc_plot(cfg);

end;

if strfind(what, 'cons'),
    
    clear cfg;

    % main config
    % cfg.N = 3:25;
    % cfg.M = 3:2:9;
    cfg.N = 3:1:41;
    cfg.M = 3:2:15;
    cfg.problem = 'dc_problem';
    cfg.X0 = 'coarse';
    cfg.mc_eps = .1;
    cfg.plot3fun = @mesh;
    cfg.savedir = imgdir;
    cfg.xlim = [cfg.N(1) cfg.N(end)];
    cfg.ylim = [cfg.M(1) cfg.M(end)];
    cfg.view = {-21, 30};

    % ------------------
    % LQR reward experiments

    lqrcfg = cfg;
    lqrcfg.model_params = 'lqr';

    % run
    rcfg = lqrcfg; rcfg.run = 1; rcfg.perf = 0;
    qiresstudy(rcfg);
    % plot perf
    scfg = lqrcfg; 
    scfg.datafile = 'fzdc_lqr_score';
    scfg.perf = 1;
    scfg.plottarget = 'latex';
    scfg.savefig = 'fzdc_lqr_score';
    scfg.zlim = [-400 -150];
    qiresstudy(scfg);

    % zoom-in on perf
    scfg.N = 10:41;
    scfg.xlim = [10 41];
    scfg.savefig = 'fzdc_lqr_score_zoomin';
    scfg.zlim = [-193 -189];
    qiresstudy(scfg);

    % ------------------
    % LQR+shaping reward experiments
    shapcfg = cfg;
    shapcfg.model_params = 'shaping';
    
    % run
    rcfg = shapcfg; rcfg.run = 1; rcfg.perf = 0;
    qiresstudy(rcfg);
    % plot perf w/ LQR reward fun
    scfg = shapcfg; 
    scfg.datafile = 'fzdc_shaping_score_lqr';
    scfg.perf = 1; scfg.userew = 'lqr';
    scfg.plottarget = 'latex';
    scfg.savefig = 'fzdc_shaping_score_lqr';
    scfg.zlim = [-400 -150];
    qiresstudy(scfg);
    
    % plot perf w/ original rew fun
    scfg = shapcfg; 
    scfg.datafile = 'fzdc_shaping_score';
    scfg.perf = 1;
    scfg.plottarget = 'latex';
    scfg.savefig = 'fzdc_shaping_score';
    scfg.zlim = [-400 -150];     % auto
    qiresstudy(scfg);

end;