% Comparison with and without envelope constraints
exp = 'all';
mode = 'stats';       % 'run', 'sol', 'stats', 'cleanup'

% main cfg
cfg = struct;
cfg.(mode) = 1;
cfg.gamma = .95;
cfg.problem = 'dc_problem';
% cfg.model_params = {'lqr Q=[5,.02] R=.05', 'lin'}; % Larger LQR weights, lin model
cfg.model_params = {'lqr', 'lin'}; % Larger LQR weights, lin model
cfg.datadir = pwd;
cfg.repeat = 5;
cfg.Ns = 5000;
cfg.xspace = 'eq'; cfg.uspace = 'log';
cfg.maxiter  = 50;
cfg.infix = 'nilc';
% perf eval
cfg.perf = 1;                       % turn off for now, we care about iter only
cfg.X0 = 'coarse';                  % when evaluating performance, use coarse grid
cfg.mc_eps = 0.1;      
% replay
cfg.x0 = [pi;0]; cfg.tend = 1.5;
if any(strcmp(mode, {'stats', 'plot'})), cfg.verb = 0; else cfg.verb = 5; end;

% dc_optimallqr(cfg);

lecfg = cfg;
lecfg.infix = 'lec';
lecfg.approx_params.ucon = @dc_linenvelope; 
lecfg.approx_params.uconinitargs = {};

expout = [];        % reset figure additions

% -------- no constraints
roexp = cfg;
roexp.type     = 'rbfortho'; roexp.miscinfo = 'ro';
roexp.N        = 9; roexp.M = 2; 
roexp.method   = 'rand';
if checkrunexp(roexp.miscinfo, exp), expout = lspiexp(roexp); end;

% -------- RBF experiments, regular inversion

rocexp = lecfg;
rocexp.type     = 'rbfortho'; rocexp.miscinfo = 'roc';
rocexp.N        = 9; rocexp.M = 2; 
rocexp.method   = 'rand';
rocexp.usesamples = roexp;
if checkrunexp(rocexp.miscinfo, exp), expout = lspiexp(rocexp); end;



