% What experiments to process and in what mode
exp = {'rq'};
mode = 'plot';       % 'run', 'sol', 'stats', 'cleanup'

% main cfg
cfg = struct;
cfg.(mode) = 2;
if strcmp(mode, 'plot'), 
    cfg.stats = 1;
    cfg.plot = {'iter'}; 
%     cfg.savefig = 'dcgamma';
%     cfg.savedir = 'D:\Work\tex\reports\2008-02-11_3wr\img\';
%     cfg.plottarget = 'latex'; 
end;
cfg.problem = 'dc_problem';
cfg.xspace = 'eq'; cfg.uspace = 'log';
cfg.maxiter  = 200;
cfg.repeat = 5;
% perf eval
cfg.perf = 0;                       % turn off for now, we care about iter only
cfg.X0 = 'coarse';                  % when evaluating performance, use coarse grid
cfg.mc_eps = 0.1;      
cfg.x0 = [pi;0]; cfg.tend = 1.5;    % for replaying
cfg.verb = 0;
cfg.datadir = pwd;
cfg.samesamples = 1; 
cfg.sstest = {'Ns'}; % THIS IS NOT TESTED -- but only active in run mode
if any(strcmp(mode, {'stats', 'plot'})), cfg.verb = 0; else cfg.verb = 5; end;

lqr2cfg = cfg;
lqr2cfg.model_params = {'lqr Q=[5,.02] R=.05', 'lin'}; % Larger LQR weights, lin model
% cell array of experiment configs
CFG = {};

% ---- Smaller parameterization
cexp = lqr2cfg;
cexp.type     = 'triang'; cexp.miscinfo = 't';
cexp.gamma    = [.95:.01:.99 .991:.001:.998];
cexp.N        = 9; cexp.M = 5;
cexp.Ns       = 10000;
CFG{end+1} = cexp;

cexp = lqr2cfg;
cexp.type     = 'rbfdisc'; cexp.miscinfo = 'r';
cexp.gamma    = [.95:.01:.99 .991:.001:.998];
cexp.N        = 9; cexp.M = 5;
cexp.Ns       = 10000;
CFG{end+1} = cexp;

cexp = lqr2cfg;
cexp.type     = 'rbfquad'; cexp.miscinfo = 'rq';
cexp.gamma    = [.95:.01:.99 .991:.001:.998];
cexp.N        = 9;
cexp.method = 'rand';
cexp.Ns       = 10000;
CFG{end+1} = cexp;

cexp = lqr2cfg;
cexp.type     = 'triangquad'; cexp.miscinfo = 'tq';
cexp.gamma    = [.95:.01:.99 .991:.001:.998];
cexp.N        = 9;
cexp.method = 'rand';
cexp.Ns       = 10000;
CFG{end+1} = cexp;


% % ---- Larger parameterization
% cexp = lqr2cfg;
% cexp.type     = 'triang'; cexp.miscinfo = 'gammaN13M5';
% % cexp.gamma    = [.95:.01:.99];
% cexp.gamma    = [.95 .96 .98 .961 .962 .964 .964 .966 .967 .968 .969];
% cexp.N        = 13; cexp.M = 5;
% cexp.repeat = 1;        % just one exp was run for this setting
% cexp.Ns       = 10000;
% CFG{end+1} = cexp;

% Main experiment loop
for i = 1:length(CFG),
    if any(strcmp(CFG{i}.miscinfo, exp)) || any(strcmp('all', exp)),
        lspiexp(CFG{i});
    end;
end;
