%% Main config
ccfg = struct;
ccfg.problem = @edro_rtproblem;
ccfg.gamma = .98;
ccfg.datadir = pwd;
% and learning settings
ccfg.trialtime = 3;
ccfg.dupd = 3;
ccfg.maxtime  = 300;
ccfg.explor = 1;
ccfg.explordecay = .955;     % decreases at roughly .1 after 38 trials (i.e., roughly half of total)
ccfg.decaytype = 'trial';
% reset 
ccfg.reset = 'randpos';
% stats settings
ccfg.verb = 5;
ccfg.eps = 0;
ccfg.trialdisp = 1;


%% run STABILIZATION experiment for joints 2 and 3
cfg = ccfg;
cfg.run = 1;
syscfg = struct;
syscfg.xjoints = [2 3];
syscfg.fixjoints = [4 5];
cfg.system_params = {syscfg};
% to make longer trials
% cfg.trialtime = 5; cfg.dupd = 5; cfg.maxtime  = 500; 
cfg.approx = 'enhanced type=rbfdisc N=[5,5,7,3] M=[3,3]';
cfg.datafile = 'test_edro_rtlspionline_jnt2x3_N5x5x7x3';
rtlspionline(cfg);

% 5,5,7,3, 3s trials, seems to work reasonably, but has resolution limitations
% 5,5,7,3, 5s trials doesn't work so well, but it's probably a random effect



%% run ROTATION experiment for joints 2 and 3
cfg = ccfg;
cfg.run = 1;
% use longer trials to follow the circle for a longer time
cfg.trialtime = 5; cfg.dupd = 5; cfg.maxtime  = 500; 
syscfg = struct;
syscfg.xjoints = [2 3];
syscfg.fixjoints = [4 5];
syscfg.rewtype = 'vectorfield';
cfg.system_params = {syscfg};
cfg.approx = 'enhanced type=rbfdisc N=[7,5,7,3] M=[3,3]';
cfg.datafile = 'test_edro_rtlspionline_circ_jnt2x3_N7x5x7x3';
rtlspionline(cfg);

