% calibrate offsets in the robot sensors
%   (c) Robert Babuska, June 2005

Port = 'COM1';
a = instrfind;
if ~isempty(a),
    for i = 1 : length(a);
        if strcmp(a(i).port,Port),
            delete(a(i));
        end;
    end;
end;    
com = xserial('Port',Port,'Baudrate',115200);
fopen(com);

rtclear all;
rtdef(1,'tick',0.01);
rtstart(1);
rtwr(1,'t',0);
for i = 1 : 50,
    fwrite(com,128,'uint8');                    % control byte for read D/A
    q = double(fread(com,7,'uint16','b'))';     % read 14 bytes from 7 sensors
    Q(i,:) = q(:)';
    while rtrd(1,'t') < i, end;                 % wait for a clock tick
end;
fclose(com);
offs = [-round(mean(Q(:,1:6))) 0];
f=fopen('hwinit.m','a');
fprintf(f,'adinoffs = [%4.0f %4.0f %4.0f %4.0f %4.0f %4.0f %4.0f]; \n',offs);
fclose(f);
