function fzip_gammastudy

% a good sample time
cfg.Ts = 0.02;
% cfg.gamma = [.95:.01:.99 .992:.002:.998];
cfg.gamma = [.95:.01:.99];
cfg.fzrun = 1;
cfg.iter = 0;
cfg.fuzzyh = 1;

cfg.rewtype = 'gauss';

% echo config
cfg

if cfg.fzrun,
    for i = 1:length(cfg.gamma),
        % run fuzzy Q-iteration
        df = generate_dfname(cfg, i);
        if ~exist([df '.mat'], 'file'),     % run experiment
            rcfg = struct;
            
            rcfg.run = 1;
            rcfg.gamma = cfg.gamma(i);
            rcfg.eps = 1e-2; 
            rcfg.maxiter = 3000;
            rcfg.problem = 'invpend_problem';
            rcfg.datadir = pwd;
            rcfg.datafile = df;
            rcfg.fuzzy_params = {'fine'};
            rcfg.model_params = {cfg.rewtype, 'rot maxu=0.8', ['Ts=' num2str(cfg.Ts)]};
            % use the same data for each exp
            if i > 1,
                rcfg.loadapprox = generate_dfname(cfg, 1);
            end;
            fuzzyqi(rcfg);
        end;
    end;
end;

if cfg.fuzzyh,
    for i = 1:length(cfg.gamma),
        repcfg.datafile = generate_dfname(cfg, i), 'd_', {'k', 'qistats'};
        repcfg.fuzzyh = 1;
        dc_plot(repcfg);
    end;
end;

iter = zeros(size(cfg.gamma));
if cfg.iter,
    for i = 1:length(cfg.gamma),
        loadwithprefix(generate_dfname(cfg, i), 'd_', {'k', 'qistats'});
        iter(i) = d_k - 1;      % iter to convergence
    end;
    figure; plot(cfg.gamma, iter, 'o--');
end;

end

% Local functions
function df = generate_dfname(cfg, i)
df = 'fzip_fine_'; 
if ~isempty(cfg.rewtype), df = [df cfg.rewtype '_']; end;
df = [df 'g' num2strx(cfg.gamma(i))];
end