% To make identical with L&Parr:
% 1. Change nrbf to rbf in rbfdisc approximator
% 2. Integration method is uncertain (tried fixedode, euler)

% Does not seem to work...
% The matrix is always not invertible! Even when Nep is increased to 1500.

% Experiment (close to)/as in Lagoudakis and Parr
cfg = struct;

acfg.c = flat({[-pi/4, 0, pi/4], [-1, 0, 1]});
acfg.rad = ones(size(acfg.c));
% this emulates a basis function equal to 1 throughout X   
acfg.c(:, end+1) = 0; acfg.rad(:, end+1) = 1e10;
acfg.ugrids = {[-50, 0, 50]};
% put on config
cfg.approx = acfg;

Nep = 1500;
% estimated # samples (according to the authors) + some slack 
N = 6*Nep+10;

% init samples arrays
X = nan(2, N); U = nan(1, N); Xp = X; R = nan(1, N);

Uflat = flat(acfg.ugrids);
M = size(Uflat, 2);
% generate samples
model = invpend_problem('model', 'fail', 'cart'); %, 'odemethod=eul odesteps=1');
s = 1;  % samples index
for i = 1:Nep,
    X(:, s) = [.1;.1] .* randn(2, 1);
    terminal = 0;
    while ~terminal,
        U(:, s) = Uflat(:, unidrnd(M));   % random noise
        [Xp(:, s), R(s), terminal] = model.fun(model, X(:, s), U(:, s) + (2*rand-1) * 10);
        if ~terminal, X(:, s+1) = Xp(:, s); end;
        s = s+1;
        if (s+5 >= size(X, 2)),   % increase arrays in steps of 1000, ahead of time
            X(1, s + 1000) = 0;
            Xp(1, s + 1000) = 0;
            U(1, s + 1000) = 0;
            R(1, s + 1000) = 0;
        end;
    end;
end;        

% form samples object
cfg.samples.method = 'lparr';
N = s-1;     % actual # of samples that were generated
N
cfg.samples.N = N;
cfg.samples.X = X(:, 1:N); 
cfg.samples.Xp = X(:, 1:N);
cfg.samples.U = U(1:N);
cfg.samples.R = R(1:N);

% clear the original arrays
clear X Xp U R

cfg.problem = 'invpend_problem';
cfg.gamma = 0.95;
cfg.model_params = {'fail'}; %, 'odemethod=eul odesteps=1'};
cfg.run = 1;
cfg.datafile = 'lspiip_lparr';
lspi(cfg);
    