clear xpos xspd xcurr xvolt;
mops('CloseAll');
h=mops('Open', 'mops1');
h.WatchdogTimeout = 2;
mops('SetParams', h);
mops('Write', h, 0, 0, 0, 0);  % dummy write to sync interface board
mops('Write', h, 1, 1, 0, 0);  % reset position, activate relay
mops('Write', h, 0, 1, 0, 0);  % end reset
version = 0;
while (version < 32)
    data = mops('Read', h);
    if (bitand(data(1), 4) ~= 4), break, end
end
version = 2;
while (version < 32)
    data = mops('Read', h);
    if (bitand(data(1), 4) ~= 4), break, end
    version = version + 1;
end
if (version == 32) 
    disp('No version number found!');
else
    disp(sprintf('The FPGA version is %d', version/2));
end
pause(0.5); % give relay some time to act
steps = 5;
% steps = 4000;
xstat = zeros(1,steps);
xpos = zeros(1,steps);
xspd = zeros(1,steps);
xcspd = zeros(1,steps);
xcurr = zeros(1,steps);
xvolt = zeros(1,steps);
xreltime = zeros(1,steps);
xabstime = zeros(1,steps);
tic;
bt = toc;
for X=1:steps
    if (X == 100000)
        mops('Write', h, 3, 1, +7.5, 0.0);
    else
        mops('Write', h, 0, 1, +7.5, 0.0);
    end
    data = mops('ReadRaw', h);
    xstat(X) = data(1);
    xreltime(X) = data(2);
    xpos(X) = data(3);
    xspd(X) = data(4);
    xcurr(X) = data(5);
    xvolt(X) = data(6);
    xcspd(X) = data(7);
    t = bt + (0.01 * X);
    %t = toc + 0.005;
    while (toc < t); end;
end
toc;
figure(1); stairs(xpos); ylabel('Position');
figure(2); stairs(xspd); ylabel('Speed');
figure(3); stairs(xcspd); ylabel('Calculated Speed');
%figure(4); stairs(xvolt); ylabel('Volt');