
%% This is the experiment used to produce the demonstration for the defense presentation
cfg = struct;
cfg.run = 1;
cfg.datadir = 'D:\Work\m\approxrl\systems\invpend_setup\lspis_onlinereal\';
cfg.datafile = 'lspisr_maxu32_Ts002_#8'; %lspisr_rbfdiscN11eqM3log_t600_tt2_rand_#1';
cfg.model_params = {[], 'type=ip maxu=3.2', 'Ts=0.02'};
    % note that maxu and Ts are changed from the typical simulation experiments
cfg.approx = 'enhanced type=rbfdisc N=11 M=3';
cfg.gamma = 0.98;
cfg.maxtime = 5 * 60;       % 5 minutes * 60 seconds
cfg.trialtime = 2;
cfg.dupd = cfg.trialtime;
cfg.ddisp = cfg.trialtime;
cfg.explordecay = 0.01^(1/(5*60)); % exploration should be .01 at 5 minutes
cfg.verb = 5;
cfg.reset = 'randdown';     % half of the times random, half pointing down
ipsetup_lspionline(cfg);


%% Experiment using the standardized RT learning framework
cfg = struct;
cfg.run = 1;
cfg.datadir = 'D:\Work\m\approxrl\systems\invpend_setup\lspis_onlinereal\';
cfg.datafile = 'lspisr_maxu32_Ts002_randdown_newstyle_#2';
% system settings (leave maxu default, =3)
cfg.problem = 'ipsetup_rtproblem';
cfg.system_params = {'Ts=0.02 maxu=3.2'};
% learning settings
cfg.approx = 'enhanced type=rbfdisc N=11 M=3';
cfg.gamma = 0.98;
cfg.maxtime  = 300;
cfg.trialtime = 2;              % trial has 2 seconds
cfg.dupd = 2;                   % parameter updates once every trial
cfg.explor = 1;                 % initial exploration rate
cfg.explordecay = 0.1^(1/75);   % 0.1 after 75 trials (i.e., half of the total #trials)
cfg.decaytype = 'trial';        % decay exploration once every trial
cfg.verb = 5;
% reset half down, half randomly -- apply random actions, with larger action bounds, for 1 second,
% and changing the action once every .2 seconds
cfg.reset = 'type=randdown rand_maxu=5 rand_time=1 rand_keep=0.2';
rtlspionline(cfg);


%% Old experiments

% Original experiment -- the one used in the LSPI chapter, some plots included in presentations, 
% and the paper draft (what paper?!?!)
% 
% cfg = struct;
% Ttrial = 2;
% 
% cfg.run = 1;
% cfg.datadir = 'D:\Work\m\approxrl\systems\invpend_setup\lspis_onlinereal\';
% cfg.datafile = 'lspis_try10_rand_keep30';
% 
% cfg.gamma = 0.98;
% cfg.maxtime = 4 * 60;       % minutes * 60
% cfg.trialtime = Ttrial;
% cfg.dupd = Ttrial;
% cfg.ddisp = Ttrial;
% cfg.explordecay = 0.01^(1/cfg.maxtime);
% cfg.reset = 'rand';
% 
% cfg.approx = 'enhanced type=rbfdisc N=11 M=3';
% 
% ipsetup_lspionline(cfg);



% % Experiment with ortho action approximation
% % Doesn't work (doesn't swing up)
% 
% cfg = struct;
% Ttrial = 2;
% 
% cfg.run = 1;
% cfg.datadir = 'D:\Work\m\approxrl\systems\invpend_setup\lspis_onlinereal\';
% cfg.datafile = 'lspis_ortho_try8_rand_keep30';
% 
% cfg.gamma = 0.98;
% cfg.maxtime = 4 * 60;       % minutes * 60
% cfg.trialtime = Ttrial;
% cfg.dupd = Ttrial;
% cfg.ddisp = Ttrial;
% cfg.explordecay = 0.01^(1/cfg.maxtime);
% cfg.reset = 'rand';
% 
% cfg.approx = 'enhanced type=rbfortho N=11 M=2';
% 
% ipsetup_lspionline(cfg);

