function [curreg]=batch_eval_oneplot(testcfg)

%% Test common config

TESTCFG.problem = 'ip';
TESTCFG.test_type = 'off';
TESTCFG.ylabel = 'average regret';
TESTCFG.test_postfix = '';
TESTCFG.algorithms = {};
TESTCFG.nsimarray = [];
TESTCFG.osp_Svals = [1];
TESTCFG.ovsp_alfa = 1;
TESTCFG.osp_Nvals = [12];

TESTCFG.plotStyle = 'oneplot'; %whether to use subplot or separate plots
TESTCFG.avgRegretGrapth = true;
TESTCFG.showDepthGraph = false;
TESTCFG.regretPoints = 1;

testcfg = checkparams(testcfg, TESTCFG);

test_problem=testcfg.problem;
test_type  = testcfg.test_type;
ylabeltext = testcfg.ylabel;
test_postfix = testcfg.test_postfix;
algorithms = testcfg.algorithms;
nsimarray =  testcfg.nsimarray;
OSP_Svals = testcfg.osp_Svals;
OVSP_alfa = testcfg.ovsp_alfa;
OSP_Nvals = testcfg.osp_Nvals;

plotStyle = testcfg.plotStyle; %whether to use subplot or separate plots
avgRegretGrapth = testcfg.avgRegretGrapth;
showDepthGraph = testcfg.showDepthGraph;
regretPoints = testcfg.regretPoints;

%% Test common config
if strcmp(test_type,'onl'),
    test_result_type = 'return';
else
    test_result_type = 'regret';
end;

switch test_problem,
    case 'ip',
        Uval = 2;   Uvalstring = ['_U' num2str(Uval)];    Uvalstring = strrep(Uvalstring,'.','_');
        probl_params = [test_problem test_type Uvalstring test_postfix '_'];
        ccfg = ip_common_config(Uval,'coarse');
    case 'hiv',
        probl_params = [test_problem test_type test_postfix '_'];
        ccfg = hiv_common_config();
end;
Usize = size(ccfg.planparams.U,2);

%% run eval
plotlinestyle = {'k-o', 'k-s', 'k--*', 'k-.d', 'k:+', 'k-x', 'k--^', 'k-.o', 'k--^', 'k-^', 'k:*', 'k-.^', 'k:o'};
avgreg   = zeros(size(algorithms,2), size(nsimarray,2)); %array for storing average regret/return for each algo, for each 'n' from the testset
reg      = zeros(size(algorithms,2), size(nsimarray,2), 403); 
avgdepth = zeros(size(algorithms,2), size(nsimarray,2));

i=1;
for algo_i = 1:size(algorithms,2),
    allresults{i}{1} = [algorithms{algo_i}{1} algorithms{algo_i}{2}];
    switch allresults{i}{1}
        case 'opd'
            allresults{i}{1} = [algorithms{algo_i}{1} algorithms{algo_i}{2}]; %name
            allresults{i}{2} = 1; %S
            allresults{i}{3} = 1; %alfa
            i = i+1;
        case {'osp','usp', 'osp_oc','osp_oc_reuse'}
%             if strcmp(allresults{i}{1},'usp'), OSP_Svals=[2 3], else OSP_Svals=[1 2 3 4 5]; end;
            
            if length(OSP_Svals)>1,
                for s=OSP_Svals
                    for nn=OSP_Nvals
                        allresults{i}{1} = [algorithms{algo_i}{1} algorithms{algo_i}{2}]; %name
                        allresults{i}{2} = s; %S
                        allresults{i}{4} = nn; %N  
                        allresults{i}{3} = 1; %alfa
                        i = i+1;
                    end;
                end
            end
        case {'ovsp','ossp','ossp2'}
            if strcmp(allresults{i}{1},'ovsp'), OVSP_alfa=[0.96], else OVSP_alfa=[0.78]; end;
            for alfa=OVSP_alfa
                allresults{i}{1} = [algorithms{algo_i}{1} algorithms{algo_i}{2}]; %name
                allresults{i}{2} = 1; %S
                allresults{i}{3} = alfa; %alfa
                i = i+1;
            end
    end
end

iii=0;
for oneresult = allresults        
        iii = iii + 1;
        figure(1);  close(1);
        algo_names{iii} = oneresult{1}{1};
        algo_names{iii} = strrep(algo_names{iii},'_','\_');
        switch algo_names{iii}
            case {'osp','usp'}
                algo_names{iii} = [algo_names{iii} ' S=' num2str(oneresult{1}{2})];
            case {'osp\_oc','osp\_oc\_reuse'}
                algo_names{iii} = [algo_names{iii} ' S=' num2str(oneresult{1}{2}) ' N=' num2str(oneresult{1}{4})];                
        end
        S=1; alfa=1;
        
        for nsim=nsimarray,
            algo_name    = oneresult{1}{1};
            algo_version = '';%oneresult{1}{1};
            nsim_i = nsimarray==nsim;
            
            algo_params = ['_nsim=' num2str(nsim)];
            switch algo_name
                case {'osp','usp'}
                    algo_params = [algo_params '_S=' num2str(oneresult{1}{2})];
                    S = oneresult{1}{2};
               case {'osp_oc','osp_oc_reuse'}
                    S = oneresult{1}{2};
                    algo_params = [algo_params '_S=' num2str(S) '_N=' num2str(oneresult{1}{4})];                      
                    
                case {'ovsp'}
                    algo_params = [algo_params '_alfa=' num2str(oneresult{1}{3}*10)];
                    alfa = oneresult{1}{3};
                case {'ossp','ossp2'}
                    algo_params = [algo_params '_alfa=' num2str(oneresult{1}{3}*10)];
                    alfa = oneresult{1}{3};
                otherwise
            end;
            
            algo_params = strrep(algo_params,'.','_');
            ccfg.datafile = [probl_params algo_name algo_version algo_params];
            
            switch test_type,
                case 'onl'
                    figure(1);
                    hist=genmpc(['plottrial addtocrt datafile=' ccfg.datafile]);
                    avgreg(iii, nsim_i)=hist.R(1); 
                otherwise
                    if avgRegretGrapth,
                        [avgreg(iii, nsim_i)] = genmpc_exp('regret', ccfg);
                    else
                        [avgreg(iii, nsim_i) reg(iii, nsim_i, :)] = genmpc_exp('regret', ccfg);
                        avgReg = 0;
                         for i=[198+[0:regretPoints-1] 206-[0:regretPoints-1]], avgReg = avgReg + reg(iii, nsim_i,i); end
                         avgreg(iii, nsim_i) = double(avgReg)/(2*regretPoints);
%                         avgreg(iii, nsim_i) = reg(iii, nsim_i, 206);
                    end;

                    if showDepthGraph,
                        load(ccfg.datafile);
                        avgK=0; 
                        for i=1:size(planinfoh,2), avgK = avgK + double(planinfoh(i).depth); end
                        avgK = double(avgK)/size(planinfoh,2);
                        avgdepth(iii, nsim_i) = avgK; %ccfg.gamma^double(avgK)/(1-ccfg.gamma);        
                    end;
            end;
        end;
end;    

algo_names
    %plot the results
    switch plotStyle
        case 'subplots'
            figure(2);     
            hold off;
    %         subplot((size(OVSP_alfa,2)>1) + 1,ceil(size(OVSP_alfa,2)/2),find(alfa==OVSP_alfa));
            subplot((size(OSP_Svals,2)>1) + 1,ceil(size(OSP_Svals,2)/2),find(S==OSP_Svals));
        case 'oneplot'
            figure(2);     
            hold on;
        case 'separate'
            figure;
    end
    for algo_i = 1:size(algo_names,2),
        hold on;
        plot(nsimarray./Usize,avgreg(algo_i,:),plotlinestyle{algo_i});
    end;
    xlabel('computational budget n');
    ylabel(ylabeltext);
    legend(algo_names);
%     title([test_problem ' onestate ' test_result_type ', S=' num2str(S) ', alfa=' num2str(OVSP_alfa)]); 

    if showDepthGraph,
        switch plotStyle
        case 'subplots'
            figure(3); 
            subplot((size(OSP_Svals,2)>1) + 1,ceil(size(OSP_Svals,2)/2),find(S==OSP_Svals));
        case 'oneplot'
            figure(3);
            hold on;
        case 'separate'
            figure;
        end
        for algo_i = 1:size(algo_names,2),
            hold on;
            plot(nsimarray./Usize,avgdepth(algo_i,:),plotlinestyle{algo_i});        
        end;
        legend(algo_names);
        xlabel('computational budget n');
        ylabel('average depth');
%         title([test_problem ' onestate treedepth, S=' num2str(S)]); 
    end;