%% ccfg
clc;
close all;  clear all;


ccfg = struct;
ccfg.problem = 'quadrotor_problem';
mcfg.rewtype = 'nlqr';
mcfg.xgoal = [6 0 1, 0 0 0, 0 0 0, 0 0 0]';         
ccfg.model_params = {mcfg}; 
ccfg.gamma = 0.98;               

ccfg.planparams = struct;
% ccfg.planparams.U = flat({[1.2508, 0, 20.0126], [-1.1807, 0, 1.1807], [-1.1807, 0, 1.1807], [-0.0488, 0, 0.0488]});    % action space -- the same as for M=3 in the approximators above
ccfg.planparams.U = flat({[1.2508, 4.3, 10], 0, [-0.01, 0, 0.01], 0});    % action space -- the same as for M=3 in the approximators above
% PAR.minu = [1.2508   -1.1807   -1.1807   -0.0488]';
% PAR.maxu = [20.0126   1.1807    1.1807    0.0488]';
ccfg.verb = 3;
ccfg.reset = [1 0 1, 0 0 0, 0 0 0, 0 0 0]';          % always reset to landed
ccfg.trials = 1;                 % one trial is enough to see performance, as we're not learning
% output config
ccfg.datadir = pwd;
% if using visualization -- set visualize to 0 to disable
ccfg.visualize = 0;



%% run online OPD
cfg = ccfg;
cfg.maxsteps = 200;
%cfg.planalg = 'ovsp_c1_v6S';            % variant: optimistic planning for deterministic systems
cfg.planalg = 'opd';            % variant: optimistic planning for deterministic systems
%cfg.planparams.nsim = 6000;         % budget of expansions at each step
cfg.planparams.n = 200;         % budget of expansions at each step
%cfg.planparams.S = 1;
cfg.datafile = ['quad_opd_n' num2str(cfg.planparams.n) ];
cfg.visualize = 0;
% cfg.saveplandata = 1;

% run the algorithm
cfg.run = 1;
genmpc(cfg);          

genmpc(['ploth datafile=' cfg.datafile]);

%figure; 
hist=genmpc(['plottrial datafile=' cfg.datafile]);
fprintf('total return=%.5f\n\n',hist.R(1));

