% A script to test how llrfittedqi works on the robot arm problem

%% Common config
clear all; close all;

ccfg = struct;
% problem config
ccfg.problem = 'rarm_problem';
ccfg.modelcfg.orientation = 'horiz';
ccfg.modelcfg.maxtau = [3 1];
ccfg.model_params = {ccfg.modelcfg};
ccfg.gamma = .98;
ccfg.maxiter  = 300;
ccfg.datadir = 'd:\work\m\approxrl\systems\rarm\rarm_llrfittedqi\';
ccfg.knn = 10;
ccfg.eps = .1;
ccfg.U = symloggrid([3 3], ccfg.modelcfg.maxtau);
ccfg.verb = 4;
ccfg.itersave = 30;
ccfg.iterdisp = 5;


%% #### PART 1: GRID SAMPLING, TESTING WEIGHTING AND SATURATION ####

ccfg1 = ccfg;
ccfg1.samples = 'method=grid xgrids=[13,7,13,7] ugrids=[3,3] gridfun=@symloggrid';
% ccfg1.samples = 'method=grid xgrids=[9,5,9,5] ugrids=[3,3] gridfun=@symloggrid';


%% uniform weighting
cfg = ccfg1;
cfg.run = 1;
cfg.wfun = 'unif';
cfg.datafile = 'llrfqirarm_horiz_grid_unif';
llrfittedqi(cfg);

%% cube weighting
cfg = ccfg1;
cfg.run = 1;
cfg.wfun = 'cube';
cfg.loadsamples = 'llrfqirarm_horiz_grid_unif';
cfg.datafile = 'llrfqirarm_horiz_grid_cube';
llrfittedqi(cfg);


%% #### PART 2: RANDOM UNIFORM SAMPLING, TESTING WEIGHTING & SATURATION ####

ccfg2 = ccfg;
ccfg2.knn = 10;
ccfg2.samples = 'method=randdisc N=(13*7*3)^2';
% ccfg2.samples = 'method=randdisc N=10000';


%% uniform weighting
cfg = ccfg2;
cfg.run = 1;
cfg.wfun = 'unif';
cfg.datafile = 'llrfqirarm_horiz_rand_unif';
llrfittedqi(cfg);

%% cube weighting
cfg = ccfg2;
cfg.run = 1;
cfg.wfun = 'cube';
cfg.loadsamples = 'llrfqirarm_horiz_rand_unif';
cfg.datafile = 'llrfqirarm_horiz_rand_cube';
llrfittedqi(cfg);