function [xkplus1] = simplewalker(xk, uk)
global torque
torque = uk; % sorry, I don't know how to pass the torque to the eom function so I make it a global variable.

% delta_t is one of the two parameters that you can vary.
delta_t = 0.1;

timespan  = [0 delta_t];
options  = odeset('events',@events);
[t,x] = ode45(@eom, timespan, xk, options);
if t(end)<delta_t
    %there was an impact!
    x_afterimpact = impact(x(end,:));
    %continue to complete the timestep
    timespan = [t(end) delta_t];
    [t,x] = ode45(@eom, timespan, x_afterimpact, options);
    % this loop could be a while loop to catch multiple impacts within one
    % timestep
end
xkplus1 = x(end,:);

function xnew = impact(xold)
% hopefully I am calculating the impacts as well as swapping the stance and
% swing leg definitions here....
thetaold    = xold(1);
phiold      = xold(2);
thetadotold = xold(3);
phidotold   = xold(4);

thetadotnew = cos(2*thetaold)*thetadotold;
phidotnew   = cos(2*thetaold)*(1 - cos(2*thetaold))*thetadotold;
thetanew    = -thetaold;
phinew      = -2*thetaold;

xnew = [thetanew, phinew, thetadotnew, phidotnew];


function xd = eom(t,x)
global torque
% gamma is the second parameter that you can vary.
gamma = 0.004;
theta    = x(1);
phi      = x(2);
thetadot = x(3);
phidot   = x(4);

qdd = [ sin(theta-gamma);
        sin(phi)*(thetadot^2-cos(theta-gamma)) + sin(theta-gamma) + torque];
    
xd = [thetadot, phidot, qdd(1), qdd(2)].';


function [value, isterminal, direction] = events(t,x)
theta    = x(1);
phi      = x(2);
value = cos(theta) - cos(phi-theta);
isterminal = (theta<-0.03) & (x(3) < 0) & (x(2) < -0.01);
direction = -1;

