mode = 'run';

% main cfg
cfg = struct;
cfg.(mode) = 1;
cfg.problem = 'dc_problem';
cfg.model_params = {'lqr Q=[5,.02] R=.05', 'lin'}; % Larger LQR weights, lin model
cfg.gamma = .95;
cfg.maxiter  = 100;
cfg.datadir = pwd;
cfg.verb = 5;

%% RBF ortho 2nd order with no policy param
cfg.approx = 'enhanced type=rbfortho N=9 M=2 xspace=eq';
cfg.samples = 'method=rand N=5000';
cfg.datafile = 'lspidc_rbfortho';
lspi(cfg);

%% RBF ortho 2nd order with policy param
cfg.approx = 'enhanced type=rbfortho N=9 M=2 xspace=eq';
cfg.samples = 'method=rand N=5000';
cfg.happrox = 'enhanced type=rbfsing N=9 xspace=eq';
cfg.hsamples = 'method=rand N=1000';
cfg.datafile = 'lspihdc_rbfortho_rbfsing';
lspih(cfg);

%% RBF ortho 2nd order with policy param & constraints
cfg.approx = 'enhanced type=rbfortho N=9 M=2 xspace=eq';
cfg.samples = 'method=rand N=5000';
cfg.happrox = 'enhanced type=rbfsing N=9 xspace=eq';
cfg.hsamples = 'method=rand N=1000';
cfg.con = 'type=mon dir=[-1,-1]';
cfg.datafile = 'lspihcondc_rbfortho_rbfsing';
lspih(cfg);
