% main cfg
cfg = struct;
% cfg.run = 1;
cfg.sol = 1;
cfg.problem = 'dc_problem';
cfg.model_params = {'lqr Q=[5,.02] R=.05', 'lin'}; % Larger LQR weights, lin model
cfg.gamma = .95;
cfg.samples = 'method=rand N=5000';
cfg.maxiter  = 100;
cfg.verb = 5;
cfg.datadir = pwd;

% RBF quad
cfg.approx = 'enhanced type=rbfquad N=9 xspace=eq';
cfg.datafile = 'lspidc_rbfquad';
lspi(cfg);

% RBF poly M=2, should give same result as above
cfg.approx = 'enhanced type=rbfpoly N=9 M=2 xspace=eq thresh=0';
cfg.loadsamples = 'lspidc_rbfquad';
cfg.datafile = 'lspidc_rbfpolyM2';
lspi(cfg);

% RBF poly M=2 thresh=1e-3, should give same result as above
cfg.approx = 'enhanced type=rbfpoly N=9 M=2 xspace=eq thresh=1e-3';
cfg.loadsamples = 'lspidc_rbfquad';
cfg.datafile = 'lspidc_rbfpolyM2_thresh';
lspi(cfg);

% RBF poly M=3
cfg.approx = 'enhanced type=rbfpoly N=9 M=3 xspace=eq';
cfg.loadsamples = 'lspidc_rbfquad';
cfg.datafile = 'lspidc_rbfpolyM3';
lspi(cfg);

% TRIANG quad
cfg.approx = 'enhanced type=triangquad N=9 xspace=eq';
cfg.datafile = 'lspidc_triangquad';
lspi(cfg);

% TRIANG poly M=2, should give same result as above
cfg.approx = 'enhanced type=triangpoly N=9 M=2 xspace=eq';
cfg.loadsamples = 'lspidc_triangquad';
cfg.datafile = 'lspidc_triangpolyM2';
lspi(cfg);

% TRIANG poly M=2, should give same result as above
cfg.approx = 'enhanced type=triangpoly N=9 M=3 xspace=eq';
cfg.loadsamples = 'lspidc_triangquad';
cfg.datafile = 'lspidc_triangpolyM3';
lspi(cfg);
