
%% Simple, robot cleaner test experiment
mcfg = struct; cfg = struct;

% mcfg.X = {[0:9]}; mcfg.x_energy = 0; mcfg.x_can = 9;  % larger world
mcfg.rew_energy = 0.2;  mcfg.rew_can = 1;   % must be in [0, 1]
mcfg.prob_char = [0.2 0];   % stochastic, 20% chance of standing still

cfg.problem = 'cleanrob_problem';
cfg.model_params = {mcfg}; 
cfg.gamma = 0.5;
cfg.planalg = 'opss';
cfg.planparams.n = 3;
cfg.planparams.L = 2;
cfg.planparams.criterion = 'contrib';
cfg.planparams.U = [-1 1];
cfg.planparams.verb = 2;
cfg.planparams.reusetree = 1;
cfg.trials = 1;
cfg.maxsteps = 30;
cfg.reset = [2];
%
cfg.saveplandata = 1;
cfg.visualize = 2;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_clopfinite_detcleanrob_contrib';

cfg.run = 1;
genmpc(cfg);



%% Simple, robot cleaner test experiment
mcfg = struct; cfg = struct;

% mcfg.X = {[0:9]}; mcfg.x_energy = 0; mcfg.x_can = 9;  % larger world
mcfg.rew_energy = 0.2;  mcfg.rew_can = 1;   % must be in [0, 1]
mcfg.prob_char = [0.2 0];   % stochastic, 20% chance of standing still

cfg.problem = 'cleanrob_problem';
cfg.model_params = {mcfg}; 
cfg.gamma = 0.5;
cfg.planalg = 'opss';
cfg.planparams.n = 20;
cfg.planparams.L = 2;
cfg.planparams.criterion = 'contrib';
cfg.planparams.U = [-1 1];
cfg.planparams.verb = 2;
cfg.trials = 1;
cfg.maxsteps = 30;
cfg.reset = [3];
%
cfg.saveplandata = 1;
cfg.visualize = 2;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_clopfinite_detcleanrob_unif';

cfg.run = 1;
genmpc(cfg);

%% Robot cleaner: x-contrib
mcfg = struct; cfg = struct;

mcfg.X = {[0:8]}; mcfg.x_energy = 0; mcfg.x_can = 8;  % larger world
mcfg.rew_energy = 0.2;  mcfg.rew_can = 1;   % must be in [0, 1]
mcfg.prob_char = [0.3 0.2];   % stochastic

cfg.problem = 'cleanrob_problem';
cfg.model_params = {mcfg}; 
cfg.gamma = 0.5;
cfg.planalg = 'opss';
cfg.planparams.n = 3;
cfg.planparams.L = 3;
cfg.planparams.criterion = 'xcontrib';
cfg.planparams.U = [-1 1];
cfg.planparams.verb = 0;
cfg.planparams.reusetree = 0;
cfg.trials = 1;
cfg.maxsteps = 200;
cfg.reset = [5];
%
cfg.saveplandata = 1;
cfg.visualize = 2;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_opss_cleanrob_xcontrib';

cfg.run = 1;
genmpc(cfg);



%% deterministic invpend setup experiment
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opss';
cfg.planparams.n = 100;
cfg.planparams.L = 1;
cfg.planparams.criterion = 'contrib';   % in fact irrelevant
cfg.planparams.actsel = 'util';
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.trials = 1;
cfg.maxsteps = 50;
cfg.reset = [-pi, 0]';
%
cfg.saveplandata = 1;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_opss_detipsetup';
cfg.run = 1;
genmpc(cfg);

%% deterministic invpend setup experiment, smaller budget -- should fail without reuse
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3', 'Ts=0.05'};
cfg.gamma = 0.9;
cfg.planalg = 'opss';
cfg.planparams.n = 30;
cfg.planparams.L = 1;
cfg.planparams.criterion = 'contrib';   % in fact irrelevant
cfg.planparams.actsel = 'util';
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.planparams.reusetree = 1;
cfg.trials = 1;
cfg.maxsteps = 80;
cfg.reset = [-pi, 0]';
%
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_opss_detipsetup_n30';
cfg.run = 1;
genmpc(cfg);

%% stochastic invpend setup experiment
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3 stoch_prob=[.6,.4] stoch_gain=[1,.7]', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opss';
cfg.planparams.n = 1000;
cfg.planparams.L = 2;
cfg.planparams.criterion = 'contrib';
cfg.planparams.actsel = 'util';
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.trials = 1;
cfg.maxsteps = 50;
cfg.reset = [-pi, 0]';
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_clopfinite_stochipsetup_p04g07_Ts005_n1000_g095';
cfg.run = 1;
genmpc(cfg);


%% stochastic invpend setup experiment, xcontrib
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3 stoch_prob=[.6,.4] stoch_gain=[1,.7]', 'Ts=0.05'};
cfg.gamma = 0.98;
cfg.planalg = 'opss';
cfg.planparams.n = 500;
cfg.planparams.L = 2;
cfg.planparams.criterion = 'contrib';
cfg.planparams.actsel = 'util';
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.trials = 1;
cfg.maxsteps = 50;
cfg.reset = [-pi, 0]';
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_opss_stochipsetup_xcontrib';
cfg.run = 1;
genmpc(cfg);


%% Study solution for invpend: traj
close all
genmpc('plottrial datafile=test_genmpc_clopfinite_detipsetup figsize=[450,370]'); movegui('center');

genmpc('plottrial datafile=test_genmpc_clopfinite_stochipsetup_contrib_util figsize=[450,370]'); movegui('northwest');
genmpc('plottrial datafile=test_genmpc_clopfinite_stochipsetup_contrib_b figsize=[450,370]'); movegui('northeast');
genmpc('plottrial datafile=test_genmpc_clopfinite_stochipsetup_ret_util figsize=[450,370]'); movegui('southwest');
genmpc('plottrial datafile=test_genmpc_clopfinite_stochipsetup_ret_b figsize=[450,370]'); movegui('southeast');

%% Study solution for invpend: depth of trees
close all;
load test_genmpc_clopfinite_stochipsetup_contrib_util planinfoh; figure; plot([planinfoh.depth]); movegui('northwest');
load test_genmpc_clopfinite_stochipsetup_contrib_b planinfoh; figure; plot([planinfoh.depth]); movegui('northeast');
load test_genmpc_clopfinite_stochipsetup_ret_util planinfoh; figure; plot([planinfoh.depth]); movegui('southwest');
load test_genmpc_clopfinite_stochipsetup_ret_b planinfoh; figure; plot([planinfoh.depth]); movegui('southeast');

%% offline: stochastic invpend
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3 stoch_prob=[.7,.3] stoch_gain=[1,.7]', 'Ts=0.05'};
cfg.gamma = 0.9;
cfg.planalg = 'opss';
cfg.planparams.n = 500;
cfg.planparams.L = 2;
cfg.planparams.criterion = 'contrib';
cfg.planparams.actsel = 'util';
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.online = 0;
cfg.X = 'smallsym';
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpcoffl_clopfinite_stochipsetup_p03g07_Ts005_n500';
cfg.run = 1;
genmpc(cfg);


%% offline: stochastic invpend - xcontrib
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3 stoch_prob=[.7,.3] stoch_gain=[1,.7]', 'Ts=0.05'};
cfg.gamma = 0.9;
cfg.planalg = 'opss';
cfg.planparams.n = 600;
cfg.planparams.L = 2;
cfg.planparams.criterion = 'xcontrib';
cfg.planparams.actsel = 'util';
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.online = 0;
cfg.X = 'smallsym';
%
cfg.saveplandata = 1;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpcoffl_opss_stochipsetup_xcontrib';
cfg.run = 1;
genmpc(cfg);

%% Deterministic robot arm arm experiment
mcfg = struct; cfg = struct;
mcfg.rewtype = 'nlqr';  % normalized!

cfg.problem = 'rarm_problem';
cfg.model_params = {mcfg}; 
cfg.gamma = 0.98;
cfg.planalg = 'opss';
cfg.planparams.n = 1000;
cfg.planparams.L = 1;
cfg.planparams.criterion = 'contrib';
cfg.planparams.actsel = 'util';
cfg.planparams.U = flat({[-3 0 3], [-2 0 2]});
cfg.planparams.verb = 1;
cfg.trials = 1;
cfg.maxsteps = 100;
cfg.reset = [-pi, 0, -pi, 0]';
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_clopfinite_detrarm_n1000';
cfg.run = 1;
genmpc(cfg);


%% Stochastic robot arm experiment
mcfg = struct; cfg = struct;

mcfg.stoch_prob = [0.2 0.8]; mcfg.stoch_gain = [0.9 1];
mcfg.rewtype = 'nlqr';  % normalized!

cfg.problem = 'rarm_problem';
cfg.model_params = {mcfg};
cfg.gamma = 0.98;
cfg.planalg = 'opss';
cfg.planparams.n = 500;
cfg.planparams.L = 4;
cfg.planparams.criterion = 'contrib';
cfg.planparams.actsel = 'util';
cfg.planparams.U = flat({[-3 0 3], [-2 0 2]});
cfg.planparams.verb = 1;
cfg.planparams.reusetree = 1;
cfg.planparams.maxtreesize = 30000;
cfg.trials = 1;
cfg.maxsteps = 75;
cfg.reset = [-pi, 0, -pi, 0]';
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_opss_stochrarm_n500_reusetree';
cfg.run = 1;
genmpc(cfg);


%% Vertical robot arm experiment
mcfg = struct; cfg = struct;

% mcfg.stoch_prob = [0.2 0.8]; mcfg.stoch_gain = [0.9 1];
mcfg.rewtype = 'nlqr';  % normalized!
mcfg.orientation = 'vert';

cfg.problem = 'rarm_problem';
cfg.model_params = {mcfg}; 
cfg.gamma = 0.95;
cfg.planalg = 'opss';
cfg.planparams.n = 1000;
cfg.planparams.lipschitz = 1;
cfg.planparams.criterion = 'contrib';
cfg.planparams.actsel = 'util';
cfg.planparams.U = flat({[-1.5 0 1.5], [-1 0 1]});
cfg.planparams.verb = 1;
cfg.planparams.reusetree = 1;
cfg.trials = 1;
cfg.maxsteps = 75;
cfg.reset = [-pi, 0, -pi, 0]';
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_clopfinite_detrarm_vert_reusetree';
cfg.run = 1;
genmpc(cfg);
