%% init

ccfg = struct;
ccfg.problem = 'ipsetup_problem';
ccfg.model_params = {'nlqr', 'type=ip maxu=3 stoch_prob=[.6,.4] stoch_gain=[1,.7]', 'Ts=0.05'};
ccfg.gamma = 0.95;
ccfg.trials = 1;
ccfg.maxsteps = 40;
ccfg.reset = [-pi, 0]';
ccfg.saveplandata = 1;
ccfg.verb = 3;
ccfg.visualize = 0;
ccfg.datadir = pwd;


%% olop small, for debugging
cfg = ccfg;
cfg.planalg = 'olop';
cfg.planparams.n = 100;
cfg.planparams.exptype = 'one';
cfg.planparams.U = [-3 3];
cfg.planparams.verb = 3;
%
cfg.datafile = 'test_genmpc_olop_temp';
cfg.run = 1;
genmpc(cfg);

%% olop with box reward, to see the effect of UCBs
cfg = ccfg;
cfg.model_params = {'nlqr', 'type=ip maxu=3 stoch_prob=[.6,.4] stoch_gain=[1,.7]', 'Ts=0.05'};
cfg.planalg = 'olop_theoretical';
cfg.planparams.n = 10000;
cfg.planparams.exptype = 'all';
cfg.planparams.U = [-3 3];
cfg.planparams.verb = 1;
% cfg.planparams.examineucb =[50 100 1000];
%
cfg.datafile = 'test_genmpc_oloptheor_nlqrrew';
cfg.run = 1;
genmpc(cfg);


%% olop
cfg = ccfg;
cfg.planalg = 'olop';
cfg.planparams.n = 5000;
cfg.planparams.exptype = 'all';
cfg.planparams.U = [-3 3];
cfg.planparams.verb = 1;
%
cfg.datafile = 'test_genmpc_olop_all_stochpsetup';
cfg.run = 1;
genmpc(cfg);


%% opss "baseline"
cfg = ccfg;
cfg.planalg = 'opss';
cfg.planparams.U = [-3 3];
cfg.planparams.L = 2;
cfg.planparams.n = round(5000 / 2 / 2);   % accounting for the fact that expansion = N x M simulations
cfg.planparams.verb = 1;
cfg.saveplandata = 0;
%
cfg.datafile = 'test_genmpc_opss_stochpsetup';
cfg.run = 1;
genmpc(cfg);


