
%% check exactness of results -- baseline, compatibility
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opd';
cfg.planparams.n = 100;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.planparams.compat = 1;
cfg.online = 0;
cfg.X = 'coarser';
%
cfg.saveplandata = 1;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_opd_variants_structures_results';
cfg.run = 1;
genmpc(cfg);

%% check exactness of results -- checks out OK against baseline
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opd';
cfg.planparams.n = 100;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.planparams.compat = 0;
cfg.online = 0;
cfg.X = 'coarser';
%
cfg.saveplandata = 1;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_opd_variants_arrays_results';
cfg.run = 1;
genmpc(cfg);

%% ntrans(itions) specified instead of n: check exactness of results againts arrays above
% OK, exactly the same results
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opd';
cfg.planparams.ntrans = 100 * 3;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.planparams.compat = 0;
cfg.online = 0;
cfg.X = 'coarser';
%
cfg.saveplandata = 1;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_opd_variants_ntrans';
cfg.run = 1;
genmpc(cfg);


%% modified version which can deal with n or depth -- set n equal to, and verify against arrays above
% (the only change is that it's run later, after implementing the modifications)
% OK -- CHECKS OUT
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opd';
cfg.planparams.n = 100;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.planparams.compat = 0;
cfg.online = 0;
cfg.X = 'coarser';
%
cfg.saveplandata = 1;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_opd_variants_ndepth-n';
cfg.run = 1;
genmpc(cfg);


%% modified version which can deal with n or depth -- set depth
% works as expected
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opd';
cfg.planparams.depth = 10;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.planparams.compat = 0;
cfg.online = 0;
cfg.X = 'coarser';
%
cfg.saveplandata = 1;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_opd_variants_ndepth-depth';
cfg.run = 1;
genmpc(cfg);

%% n or depth -- online control with fixed n, no sequences
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opd';
cfg.planparams.n = 100;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.planparams.compat = 0;
cfg.online = 1;
cfg.reset = [-pi; 0];
cfg.maxsteps = 40;
%
cfg.saveplandata = 1;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_opd_variants_ndepth-n_online';
cfg.run = 1;
genmpc(cfg);

genmpc('plottrial datafile=test_genmpc_opd_variants_ndepth-n_online');

%% n or depth -- online control with fixed n, WITH sequences
% solution takes more time but seems better, as expected
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opd';
cfg.planparams.n = 1000;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.planparams.compat = 0;
cfg.online = 1;
cfg.actiontype = 'seq';
cfg.reset = [-pi; 0];
cfg.maxsteps = 80;
%
cfg.saveplandata = 1;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_opd_variants_ndepth-n_seq';
cfg.run = 1;
genmpc(cfg);

genmpc('plottrial datafile=test_genmpc_opd_variants_ndepth-n_seq');

%% n or depth -- online control with fixed d, no sequences
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opd';
cfg.planparams.depth = 6;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.planparams.compat = 0;
cfg.online = 1;
cfg.actiontype = 'one';
cfg.reset = [-pi; 0];
cfg.maxsteps = 80;
%
cfg.saveplandata = 1;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_opd_variants_ndepth-depth_one';
cfg.run = 1;
genmpc(cfg);

genmpc('plottrial datafile=test_genmpc_opd_variants_ndepth-depth_one');

%% n or depth -- online control with fixed d, WITH sequences
% solution takes more time but seems better, as expected
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opd';
cfg.planparams.depth = 6;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.planparams.compat = 0;
cfg.online = 1;
cfg.actiontype = 'seq';
cfg.maxseqlen = 6;
cfg.reset = [-pi; 0];
cfg.maxsteps = 80;
%
cfg.saveplandata = 1;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_opd_variants_ndepth-depth_seq';
cfg.run = 1;
genmpc(cfg);

genmpc('plottrial datafile=test_genmpc_opd_variants_ndepth-depth_seq');