% Test variant of OPSS that uses handle objects for the tree nodes 


%% 
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3 stoch_prob=[.7,.3] stoch_gain=[1,.7]', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opss';
cfg.planparams.n = 500;
cfg.planparams.L = 2;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.planparams.compat = 1;
cfg.planparams.treesizeincrement = 0;
cfg.online = 0;
cfg.X = 'smallsym';
%
cfg.saveplandata = 1;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_opss_variants_structures_matlabr2006b';
cfg.run = 1;
genmpc(cfg);


%% 
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3 stoch_prob=[.7,.3] stoch_gain=[1,.7]', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opss';
cfg.planparams.n = 500;
cfg.planparams.L = 2;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.planparams.compat = 2;
cfg.saveplandata = 1;
cfg.online = 0;
cfg.X = 'smallsym';
%
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_opss_variants_objects';
cfg.run = 1;
genmpc(cfg);

%% 
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3 stoch_prob=[.7,.3] stoch_gain=[1,.7]', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opss';
cfg.planparams.n = 500;
cfg.planparams.L = 2;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.planparams.compat = 0;
cfg.planparams.treesizeincrement = 10000;
cfg.online = 0;
cfg.X = 'smallsym';
%
cfg.saveplandata = 1;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_opss_variants_arrays_matlabr2006b_inittrees';
cfg.run = 1;
genmpc(cfg);




%% check exactness of results -- baseline
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3 stoch_prob=[.7,.3] stoch_gain=[1,.7]', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opss';
cfg.planparams.n = 500;
cfg.planparams.L = 2;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.planparams.compat = 1;
cfg.online = 0;
cfg.X = 'coarser';
%
cfg.saveplandata = 1;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_opss_variants_structures_results';
cfg.run = 1;
genmpc(cfg);

%% check exactness of results -- checks out OK against baseline
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3 stoch_prob=[.7,.3] stoch_gain=[1,.7]', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opss';
cfg.planparams.n = 500;
cfg.planparams.L = 2;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.planparams.compat = 0;
cfg.planparams.treesizeincrement = 10000;
cfg.online = 0;
cfg.X = 'coarser';
%
cfg.saveplandata = 1;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_opss_variants_arrays_results';
cfg.run = 1;
genmpc(cfg);

