
%% Simple, robot cleaner test experiment
mcfg = struct; cfg = struct;
mcfg.rew_energy = 0.2;  mcfg.rew_can = 1;   % must be in [0, 1]

cfg.problem = 'cleanrob_problem';
cfg.model_params = {mcfg}; 
cfg.gamma = 0.5;
cfg.planalg = 'optplan';
cfg.planparams.n = 10;
cfg.planparams.U = [-1 1];
cfg.planparams.verb = 2;
cfg.trials = 1;
cfg.maxsteps = 30;
cfg.reset = [3];
%
cfg.saveplandata = 1;
cfg.visualize = 2;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_optplan_detcleanrob';

cfg.run = 1;
genmpc(cfg);


%% invpend setup experiment
cfg = struct;

cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3', 'Ts=0.05'};
cfg.gamma = 0.9;
cfg.planalg = 'optplan';
cfg.planparams.n = 500;
cfg.planparams.U = [-3 0 3];
cfg.planparams.verb = 1;
cfg.trials = 1;
cfg.maxsteps = 80;
cfg.reset = [-pi, 0]';
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_optplan_detipsetup';
cfg.run = 1;
genmpc(cfg);


%% Robot arm experiment
mcfg = struct; cfg = struct;
mcfg.rewtype = 'nlqr';  % normalized!

cfg.problem = 'rarm_problem';
cfg.model_params = {mcfg}; 
cfg.gamma = 0.98;
cfg.planalg = 'optplan';
cfg.planparams.n = 500;
cfg.planparams.U = flat({[-3 0 3], [-2 0 2]});
cfg.planparams.verb = 1;
cfg.trials = 1;
cfg.maxsteps = 50;
cfg.reset = [-pi, 0, -pi, 0]';
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_genmpc_optplan_detrarm';
cfg.run = 1;
genmpc(cfg);

