%% Horizontal, deterministic robot arm arm experiment
mcfg = struct; cfg = struct;
mcfg.rewtype = 'nlqr';  % normalized!

cfg.problem = 'rarm_problem';
cfg.model_params = {mcfg}; 
cfg.gamma = 0.98;
cfg.planalg = 'opd';
cfg.planparams.n = 300;
cfg.planparams.U = flat({[-1.5 0 1.5], [-1 0 1]});
cfg.planparams.verb = 1;
cfg.trials = 1;
cfg.maxsteps = 100;
cfg.reset = [pi/2, 0, 0, 0]';
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_opd_rarm_stabilization';
cfg.run = 1;
genmpc(cfg);
% 
%
% %% Vertical robot arm experiment
% mcfg = struct; cfg = struct;
% mcfg.rewtype = 'nlqr';  % normalized!
% mcfg.orientation = 'vert';
% 
% cfg.problem = 'rarm_problem';
% cfg.model_params = {mcfg}; 
% cfg.gamma = 0.98;
% cfg.planalg = 'opd';
% cfg.planparams.usemem = 1;
% cfg.planparams.L = 1;
% cfg.planparams.n = 1000;
% cfg.planparams.U = flat({[-1.5 0 1.5], [-1 0 1]});
% cfg.planparams.verb = 1;
% cfg.trials = 1;
% cfg.maxsteps = 75;
% cfg.reset = [-pi, 0, -pi, 0]';
% %
% cfg.saveplandata = 0;
% cfg.verb = 3;
% cfg.visualize = 0;
% cfg.datadir = pwd;
% cfg.datafile = 'test_opd_rarm_swingup';
% cfg.run = 1;
% genmpc(cfg);

%% Ref traj experiment
mcfg = struct; cfg = struct;
mcfg.orientation = 'horiz';
mcfg.rewtype = 'refmodel';
mcfg.refmodel_params = {[.35; .35], .2, 2*pi/3};

cfg.problem = 'rarm_problem';
cfg.model_params = {mcfg}; 
cfg.gamma = 0.98;
cfg.planalg = 'opd';
cfg.planparams.n = 400;
cfg.planparams.U = flat({[-1.5 0 1.5], [-1 0 1]});
cfg.planparams.verb = 1;
cfg.trials = 1;
cfg.maxsteps = 200;
cfg.reset = [0, 0, 0, 0]';
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_opd_rarm_reftraj';
cfg.run = 1;
genmpc(cfg);

