
%% Main config 1: normalized LQR
% with this a near-optimal solution is possible w/ discrete actions
mcfg = struct;
mcfg.rewtype = 'nlqrref';
mcfg.Qrew = diag([1 0]);
mcfg.Rrew = 0;
model = resonatingarm_problem('model', mcfg);

%% Main config 1: exp reward
% with this a near-optimal solution is possible w/ discrete actions
mcfg = struct;
mcfg.rewtype = 'exp';
mcfg.Crew =  diag([2 0.07 0.001]);        % lex' value
% mcfg.Crew =  diag([1 0 0]);        % lex' value
model = resonatingarm_problem('model', mcfg);


%% Fuzzy QI solution
cfg = struct;
cfg.problem = 'resonatingarm_problem';
cfg.model_params = {mcfg};
cfg.xgrids = symequidgrid([81 31], model.maxx);
cfg.ugrids = {symloggrid(17, model.maxu)};   % fuzzyqi expects cell array so wrap as one
cfg.gamma = 0.95;
cfg.eps = 1e-5;
cfg.maxiter = 1000;
cfg.datadir = pwd;
cfg.datafile = 'test_soop_resonatingarm_exp_fzqisol_Clex';
cfg.run = 1;
cfg.verb = 10;
cfg.initstepdisp = 0.1;
cfg.itersave = 1000;
fuzzyqi(cfg);

%% 
cfg = struct;
cfg.problem = 'resonatingarm_problem';
cfg.model_params = {mcfg}; 
cfg.gamma = 0.95;
cfg.planalg = 'sooplp';
cfg.planparams.method = 'soop';
cfg.planparams.n = 2500;
cfg.planparams.dimselect = 'disc';
cfg.planparams.alpha = 0.7;
cfg.planparams.verb = 1;
cfg.trials = 1;
cfg.maxsteps = 100;
cfg.reset = [-.85 0]';
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_soop_resonatingarm_soop_exp_n2500_alpha07_Clex';
cfg.run = 1;
genmpc(cfg);

%% 
cfg = struct;
cfg.problem = 'resonatingarm_problem';
cfg.model_params = {mcfg}; 
cfg.gamma = 0.95;
cfg.planalg = 'opd';
cfg.planparams.U = [-2 0 2];
cfg.planparams.ntrans = 2500;
cfg.planparams.verb = 1;
cfg.trials = 1;
cfg.maxsteps = 100;
cfg.reset = [-.85 0]';
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_soop_resonatingarm_exp_opd_Clex';
cfg.run = 1;
genmpc(cfg);


