% A script to test llrfittedqi

%% Common config for invpend problem
ccfg = struct;
ccfg.problem = 'ipsetup_problem';
ccfg.gamma = .98;
ccfg.datadir = 'd:\work\m\approxrl\testing\test_llrfittedqi_llrapprox_ipsetup\';
ccfg.knn = 10;
ccfg.U = {[-3 0 3]};
ccfg.verb = 2;

cd(ccfg.datadir);

%% Trajectory sampling -- near-optimal policy
% get a reasonable solution to produce informative samples
load d:\work\m\approxrl\systems\invpend_setup\llrfqi_ip_lspicomparison\lspi_ip_Nsgrid_triang_N11x11_grid_xgr71x71 approx theta

cfg = ccfg;
cfg.maxiter = 300;
cfg.samples.method = 'trajdisc';
cfg.samples.ugrids = cfg.U;
cfg.samples.N = 3200;
cfg.samples.traj_K = 400;
cfg.samples.traj_X0 = [-pi, 0]';
cfg.samples.policy = @(x, t) approx.h(approx, theta, x);
cfg.samples.explor = 0;                        % 10% exploration prob
cfg.datafile = 'test_illrfittedqi_llrfittedqibaseline';
cfg.run = 1;
llrfittedqi(cfg);


%% Interlaced using a single meta-iteration -- results should be the same as above
% get a reasonable solution to produce informative samples
load d:\work\m\approxrl\systems\invpend_setup\llrfqi_ip_lspicomparison\lspi_ip_Nsgrid_triang_N11x11_grid_xgr71x71 approx theta

cfg = ccfg;
cfg.maxtau = 1;
cfg.maxiter = 300;
cfg.Nstau = 3200;
cfg.maxsteps = 400;
cfg.X0 = [-pi, 0]';
cfg.h0 = @(x, t) approx.h(approx, theta, x);
cfg.explor = 0;                        % 10% exploration prob
cfg.datafile = 'test_illrfittedqi_maxtau1';
cfg.run = 1;
cfg.verb = 3;
illrfittedqi(cfg);

%% Interlaced using several meta-iterations

% Settings that were tried and didn't work:

% maxtau10, maxiter50, Nstau1200, maxsteps400, explor.2 -- not working
% maxtau10, maxiter200, Nstau1200, maxsteps400, explor.2  -- not working
%       -- change to similar settings as in Damien's HIV paper
% cfg.maxtau = 3; cfg.maxiter = 300; cfg.Nstau = 6000; cfg.maxsteps = 400; cfg.explor = .15; 

%test_illrfittedqi1:
% cfg.maxtau = 50; cfg.maxiter = 10; cfg.Nstau = 400; cfg.maxsteps = 400; cfg.explor = .15; 

%test_illrfittedqi2:
% cfg.maxtau = 50; cfg.maxiter = 100; cfg.Nstau = 400; cfg.maxsteps = 400; cfg.explor = .15; 

%test_illrfittedqi3: same thing, but code temporarily changed to always reset Qs to zeros
% cfg.maxtau = 50; cfg.maxiter = 100; cfg.Nstau = 400; cfg.maxsteps = 400; cfg.explor = .15; 

% test_illrfittedqi4: smaller knn
% cfg.knn = 7; cfg.maxtau = 30; cfg.maxiter = 300; cfg.Nstau = 800; cfg.maxsteps = 400; cfg.explor = .15; 

% test_illrfittedqi5: lower exploration
% cfg.knn = 7; cfg.maxtau = 30; cfg.maxiter = 300; cfg.Nstau = 400; cfg.maxsteps = 400; cfg.explor = .05; 

% test_illrfittedqi6: from now on WITH DUPLICATES REMOVAL (exploration changed back)
% cfg.knn = 7; cfg.maxtau = 30; cfg.maxiter = 300; cfg.Nstau = 400; cfg.maxsteps = 400; cfg.explor = .15; 

% test_illrfittedqi_ip_largeexplor:
% cfg.knn = 7; cfg.maxtau = 20; cfg.maxiter = 300; cfg.Nstau = 400; cfg.maxsteps = 400; cfg.explor
% = .8; 

% test_illrfittedqi_ip_knn20:
% cfg.knn = 20; cfg.maxtau = 20; cfg.maxiter = 300; cfg.Nstau = 400; cfg.maxsteps = 400; cfg.explor = .15; 


cfg = ccfg;
cfg.knn = 20; cfg.maxtau = 20; cfg.maxiter = 300; cfg.Nstau = 400; cfg.maxsteps = 400; cfg.explor = .15; 
cfg.X0 = [-pi 0]';
cfg.datafile = 'test_illrfittedqi_ip_largeexplor';
cfg.run = 1;
cfg.verb = 3;
illrfittedqi(cfg);


%% Common config for hillcar problem
ccfg = struct;
ccfg.problem = 'hillcar_problem';
ccfg.gamma = .95;
ccfg.datadir = 'd:\work\m\approxrl\testing\test_llrfittedqi_llrapprox_ipsetup\';
ccfg.eps = .01;
ccfg.epsper = .01;
ccfg.U = {[-4 4]};
ccfg.verb = 2;

cd(ccfg.datadir);

%% Interlaced LLRfittedQI

% 1: cfg.knn = 7; cfg.maxtau = 20; cfg.maxiter = 300; cfg.Nstau = 800; cfg.maxsteps = 100; cfg.explor = .15; 
% 2: cfg.knn = 3; cfg.maxtau = 20; cfg.maxiter = 300; cfg.Nstau = 800; cfg.maxsteps = 100; cfg.explor = .15; 
    % seems to be working but it's an accident
% 3: repeat cfg.knn = 7; cfg.maxtau = 20; cfg.maxiter = 300; cfg.Nstau = 800; cfg.maxsteps = 100; cfg.explor = .15; 

% test_illrfittedqi_hc_knn4:
% cfg.knn = 4; cfg.maxtau = 20; cfg.maxiter = 300; cfg.Nstau = 800; cfg.maxsteps = 100; cfg.explor = .15; 

% test_illrfittedqi_hc_knn3_2:
% repeat cfg.knn = 3; cfg.maxtau = 20; cfg.maxiter = 300; cfg.Nstau = 800; cfg.maxsteps = 100; cfg.explor = .15; 
% NOT WORKING -- so it worked by accident...

cfg = ccfg;
cfg.knn = 3; cfg.maxtau = 20; cfg.maxiter = 300; cfg.Nstau = 800; cfg.maxsteps = 100; cfg.explor = .15; 
cfg.X0 = [0 0]';
cfg.datafile = 'test_illrfittedqi_hc_knn3_3';
cfg.run = 1;
cfg.verb = 3;
illrfittedqi(cfg);



%% Common config for bike balancing problem
ccfg = struct;
ccfg.problem = 'bike_problem';
ccfg.gamma = .98;
ccfg.datadir = 'd:\work\m\approxrl\testing\test_llrfittedqi_llrapprox_ipsetup\';
ccfg.eps = .01;
ccfg.model_params = {struct('det', 1)};    % deterministic bike
ccfg.epsper = .01;
ccfg.U = {0, [-2 0 2]};                 % only steering, no displacement (at least for now)
ccfg.X0 = [5*pi/180 0 0 0]';
ccfg.verb = 2;

cd(ccfg.datadir);

%% Interlaced LLRfittedQI

% test_illrfittedqi_bike_1: no duplicate removal
% cfg.knn = 7; cfg.maxtau = 10; cfg.maxiter = 300; cfg.Nstau = 1000; cfg.maxsteps = 1000; cfg.explor = .1; 

% test_illrfittedqi_bike_2: from now on with duplicate removal

cfg = ccfg;
cfg.knn = 7; cfg.maxtau = 10; cfg.maxiter = 300; cfg.Nstau = 1000; cfg.maxsteps = 1000; cfg.explor = .1; 
cfg.datafile = 'test_illrfittedqi_bike_2';
cfg.run = 1;
cfg.verb = 3;
illrfittedqi(cfg);



%% Common config for DC motor problem
ccfg = struct;
ccfg.problem = 'dc_problem';
ccfg.model_params = {'lqr Q=[5,.02] R=.05', 'lin'}; % Larger LQR weights, lin model
ccfg.gamma = .98;
ccfg.datadir = 'd:\work\m\approxrl\testing\test_llrfittedqi_llrapprox_ipsetup\';
ccfg.U = {[-10 0 10]};
ccfg.X0 = [-pi, 0];
ccfg.verb = 2;

cd(ccfg.datadir);


%% Interlaced LLRfittedQI

% test_illrfittedqi_dc_1: 
cfg = ccfg;
cfg.knn = 7; cfg.maxtau = 30; cfg.maxiter = 300; cfg.Nstau = 200; cfg.maxsteps = 200; cfg.explor = .15; 
cfg.datafile = 'test_illrfittedqi_dc_1';
cfg.run = 1;
cfg.verb = 3;
illrfittedqi(cfg);

%% Common config for HIV problem
ccfg = struct;
ccfg.problem = 'hiv_problem';
ccfg.model_params = {'filter=none'}; % Larger LQR weights, lin model
ccfg.gamma = .98;
ccfg.datadir = 'd:\work\m\approxrl\testing\test_llrfittedqi_llrapprox_ipsetup\';
ccfg.U = {[0, 0.7], [0, 0.3]};
ccfg.X0 = 'unhealthy';

cd(ccfg.datadir);


%% Interlaced LLRfittedQI

% test_illrfittedqi_dc_1: 
cfg = ccfg;
% same settings as in Damien's paper
cfg.knn = 10; cfg.maxtau = 10; cfg.maxiter = 400; cfg.Nstau = 1000; cfg.maxsteps = 200; cfg.explor = .15; 
cfg.datafile = 'test_illrfittedqi_hiv';
cfg.run = 1;
cfg.verb = 3;
illrfittedqi(cfg);


