% %% Zero-action control just to test the dynamics / reward function
% mcfg = struct; 
% % mcfg.nagents = 3; mcfg.G = [0 1 0; 1 0 1; 0 1 0];
% mcfg.nagents = 2; mcfg.G = [0 1; 1 0];
% mcfg.orientation = 'vertical';
% 
% cfg = struct;
% cfg.problem = 'mararm_problem';
% cfg.model_params = {mcfg}; 
% cfg.gamma = 0.98;
% % anon function for the planning algorithm
% cfg.planalg = 'maplan_zeroaction';
% cfg.trials = 1;
% cfg.maxsteps = 200;
% % cfg.reset = [pi/2, 0, 0, 0; -pi, 0, 0, 0; -pi/2, 0, 0, 0]';
% cfg.reset = [-pi/2, -2*pi, -pi/2, -2*pi; pi/2, 2*pi, pi/2, 2*pi]';
% %
% cfg.saveplandata = 0;
% cfg.verb = 3;
% cfg.visualize = 0;
% cfg.datadir = pwd;
% cfg.datafile = 'test_mararm_zeroaction';
% cfg.run = 1;
% magenmpc(cfg);
% 
% %% OPD
% mcfg = struct; 
% mcfg.nagents = 3; mcfg.G = [0 1 0; 1 0 1; 0 1 0];
% mcfg.orientation = 'horizontal';
% mcfg.Q = diag([1 .05 .1 .05]);
% 
% cfg = struct;
% cfg.problem = 'mararm_problem';
% cfg.model_params = {mcfg}; 
% cfg.gamma = 0.98;
% cfg.comm = 'seq';
% % anon function for the planning algorithm
% cfg.planalg = 'maopd_predictneighbors';
% cfg.planparams.n = 500;
% cfg.planparams.U = repmat({{[-1.5, 0, 1.5], [-1, 0, 1]}}, 1, mcfg.nagents);
% cfg.planparams.xpredtype = 'comm';
% cfg.planparams.verb = 1;
% cfg.trials = 1;
% cfg.maxsteps = 200;
% cfg.reset = [pi/2, 0, 0, 0; 0, 0, 0, 0; -pi/2, 0, 0, 0]';
% %
% cfg.saveplandata = 0;
% cfg.verb = 3;
% cfg.visualize = 0;
% cfg.datadir = pwd;
% cfg.datafile = 'test_mararm_opd';
% cfg.run = 1;
% magenmpc(cfg);
% 
% 
% %% 3. Leader-based consensus
% % MAS config
% macfg = struct; 
% % directed graph 1 --> 2 <--> 3
% % macfg.nagents = 3; macfg.G = [0 0 0; 1 0 1; 0 1 0]; 
% % symmetric graph 2 <-- 1 --> 3; should be equiv to ref tracking; for debugging
% macfg.nagents = 2; macfg.G = [0 0; 1 0]; 
% macfg.orientation = 'horizontal';
% macfg.Q = diag([1 .1 .5 .1]);
% 
% % leader, single-agent config
% lcfg = struct;
% lcfg.orientation = 'horiz';
% lcfg.rewtype = 'refmodel';
% lcfg.refmodel_params = {[.35; .35], .2, 2*pi/3};
% 
% cfg = struct;
% cfg.problem = 'mararm_problem';
% cfg.model_params = {macfg}; 
% cfg.gamma = 0.98;
% cfg.comm = 'seq';
% % leader
% cfg.leadproblem = 'rarm_problem';
% cfg.leadmodel_params = {lcfg};
% cfg.leadplanalg = 'opd';
% cfg.leadplanparams.n = 400;
% cfg.leadplanparams.U = flat({[-1.5 0 1.5], [-1 0 1]});
% % other agents
% cfg.planalg = 'maopd_predictneighbors';
% cfg.planparams.n = 400;
% cfg.planparams.U = repmat({{[-1.5, 0, 1.5], [-1, 0, 1]}}, 1, macfg.nagents);
% cfg.planparams.xpredtype = 'comm';
% cfg.planparams.verb = 1;
% cfg.trials = 1;
% cfg.maxsteps = 100;
% % notice here the leader starts at 0, above the center agent with index 2 started at 0
% cfg.leadreset = [0 0 0 0]';
% cfg.reset = [0 0 0 0; pi/2 0 0 0]';
% %
% cfg.saveplandata = 0;
% cfg.verb = 3;
% cfg.visualize = 0;
% cfg.datadir = pwd;
% cfg.datafile = 'mararm_maopd_leadconsensus_G1-)2';
% cfg.run = 1;
% magenmpc(cfg);
% 

%% Leader-based consensus with zero trajectory of the leader
% MAS config
macfg = struct; 
% directed graph 1 --> 2 <--> 3
% macfg.nagents = 3; macfg.G = [0 0 0; 1 0 1; 0 1 0]; 
% symmetric graph 2 <-- 1 --> 3; should be equiv to ref tracking; for debugging
macfg.nagents = 2; macfg.G = [0 0; 1 0]; 
macfg.orientation = 'horiz';
macfg.Q = diag([1 .1 .5 .1]);

% leader, single-agent config
lcfg = struct;
lcfg.orientation = 'horiz';
lcfg.rewtype = 'nlqr';
% lcfg.refmodel_params = {[.35; .35], .2, 2*pi/3};
lcfg.Q = diag([1 .1 .5 .1]);
% lcfg.R = diag([.05 .05]);

cfg = struct;
cfg.problem = 'mararm_problem';
cfg.model_params = {macfg}; 
cfg.gamma = 0.98;
cfg.comm = 'seq';
% leader
cfg.leadproblem = 'rarm_problem';
cfg.leadmodel_params = {lcfg};
cfg.leadplanalg = 'opd';
cfg.leadplanparams.n = 50;
cfg.leadplanparams.U = flat({[-1.5 0 1.5], [-1 0 1]});
% other agents
cfg.planalg = 'maopd_predictneighbors';
cfg.planparams.n = 400;
cfg.planparams.U = repmat({{[-1.5, 0, 1.5], [-1, 0, 1]}}, 1, macfg.nagents);
cfg.planparams.xpredtype = 'comm';
cfg.planparams.verb = 1;
cfg.trials = 1;
cfg.maxsteps = 100;
% notice here the leader starts at 0, above the center agent with index 2 started at 0
cfg.leadreset = [0 0 0 0]';
cfg.reset = [0 0 0 0; pi/2 0 0 0]';
%
cfg.saveplandata = 0;
cfg.verb = 3;
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'mararm_maopd_leadconstest';
cfg.run = 1;
magenmpc(cfg);