%% Computational test of OPSS algo with memory
cfg = struct;
 
cfg.problem = 'ipsetup_problem';
cfg.model_params = {'nlqr', 'type=ip maxu=3 stoch_prob=[.7,.3] stoch_gain=[1,.7]', 'Ts=0.05'};
cfg.gamma = 0.95;
cfg.planalg = 'opss';
cfg.planparams.n = 100;
cfg.planparams.L = 2;
cfg.planparams.U = [-3 0 3];
cfg.planparams.usemem = 1; 
cfg.planparams.mem_maxsize = 1;
cfg.planparams.lipschitz = 0.5; 
cfg.planparams.verb = 2;

% 
cfg.online = 1;
cfg.x0 = [-pi; 0];
cfg.trials = 1;
cfg.maxsteps = 50;
% 
cfg.saveplandata = 0;
cfg.verb = 3; 
cfg.visualize = 0;
cfg.datadir = pwd;
cfg.datafile = 'test_ip_stoch_opss_usemem';
cfg.run = 1;


% run a few times
N = 10; t = zeros(N, 1);
for i = 1:N,
    tic;
    genmpc(cfg);
    t(i) = toc;
end;
disp(sprintf('Execution time: mean %.3f, std %.3f', mean(t), std(t)));
