setups = struct;
setups.eulerN1 = 'odemethod=eul odesteps=1 Ts=.05';
setups.ode4N1 = 'odemethod=fixedode odesolver=@ode4 odesteps=1 Ts=.05';
setups.ode45 = 'odemethod=varode odesolver=@ode45 Ts=.05';
% setups.ode15s = 'odemethod=varode odesolver=@ode15s';

mcfg.type = 'nowrap';
mcfg.l = .04;
mcfg.m = .03;
mcfg.J = 10e-5 + mcfg.m*mcfg.l^2;
mcfg.maxx = [10*pi; 50*pi];

cfg.x0 = [0.1,0];
cfg.pause = 0;
cfg.tend = 4;
cfg.preargs = {'',mcfg};
% cfg.policy = @(x, t) 1.5*square(t*2);
cfg.policy = @(x, t) 0;

figure;
[evols, times, figh] = odetest('ipsetup_problem', cfg, setups);


%% fuzzy QI Thijs invpend system

mcfg = struct;
mcfg.type = 'ip';
mcfg.l = .04;
mcfg.m = .03;
mcfg.J = 10e-5 + mcfg.m*mcfg.l^2;
mcfg.maxx = [pi; 50*pi];

cfg = struct;
cfg.problem = 'ipsetup_problem';
cfg.gamma = 0.95;
cfg.model_params = {[], mcfg, 'odemethod=fixedode odesolver=@ode4 odesteps=1 Ts=.05'};
cfg.eps = 1e-3;
cfg.datadir = pwd;
N = [101 101]; M = 3; maxu = 0.9;
cfg.xgrids = symequidgrid(N, mcfg.maxx');
cfg.ugrids = {symequidgrid(M, maxu)};
cfg.run = 1;
cfg.savetheta = 1;
cfg.datafile = 'ipsetup_fuzzyqi';
%
cfg.iterdisp = 5;
fuzzyqi(cfg);

%% replay
fuzzyqi('replay datafile=ipsetup_fuzzyqi x0=[-pi,0] tend=5');

%% replay with the real system
ipsetup_control('Ts=.05 maxu=3 maxomega=50*pi htype=fuzzy datafile=ipsetup_fuzzyqi x0=down tend=5');

