% A script to test all variants of LSPI/LSPE

% main cfg
ccfg = struct;
ccfg.problem = 'ipsetup_problem';
ccfg.gamma = .98;
ccfg.maxiter  = 100;
ccfg.datadir = pwd;
ccfg.verb = 5;
ccfg.approx = 'enhanced type=rbfdisc N=11 M=5 xspace=eq uspace=eq';
ccfg.samples = 'method=randdisc N=10000';
ccfg.happrox = 'enhanced type=rbfsing N=11 xspace=eq';
ccfg.hsamples = 'method=rand N=3000';


% % LSPI
% cfg = ccfg;
% cfg.run = 1;
% cfg.datafile = 'test_lspi';
% lspi(cfg);
% % Run code below to test execution time statistics
% all(timestat.iter_computeAb + timestat.iter_qsolve == timestat.iter_peval)
% all(timestat.iter_peval + timestat.iter_convtest == timestat.iter_run)
% sum(timestat.iter_run) == timestat.run
% timestat.qsamples + timestat.precomputephi + timestat.precomputeAb == timestat.init
% trun == timestat.run


% % LSPE with "online" param updates
% cfg = ccfg;
% cfg.run = 1;
% cfg.maxiter = 4;
% cfg.datafile = 'test_lspe_duringsamples';
% lspe(cfg);
% % Run code below to test execution time statistics
% all(timestat.iter_peval + timestat.iter_convtest == timestat.iter_run)
% sum(timestat.iter_run) == timestat.run
% timestat.qsamples + timestat.precomputephi == timestat.init
% trun == timestat.run
% 
% % LSPE with "offline" param updates
% cfg = ccfg;
% cfg.run = 1;
% cfg.maxiter = 4;
% cfg.datafile = 'test_lspe_aftersamples';
% cfg.evalduringsamples = 0;
% lspe(cfg);
% % Run code below to test execution time statistics
% all(timestat.iter_peval + timestat.iter_convtest == timestat.iter_run)
% sum(timestat.iter_run) == timestat.run
% timestat.qsamples + timestat.precomputephi + timestat.precomputeAb == timestat.init
% trun == timestat.run

% % LSPIH
% cfg = ccfg;
% cfg.run = 1;
% cfg.datafile = 'test_lspih';
% lspih(cfg);
% % Run code below to test execution time statistics
% all(timestat.iter_computeAb + timestat.iter_qsolve == timestat.iter_peval)
% all(timestat.iter_computeh + timestat.iter_hsolve == timestat.iter_pimpr)
% all(timestat.iter_peval + timestat.iter_pimpr + timestat.iter_convtest == timestat.iter_run)
% sum(timestat.iter_run) == timestat.run
% timestat.qsamples + timestat.precomputephi + timestat.hsamples + timestat.precomputehphi == timestat.init
% trun == timestat.run

% % LSPI online
% cfg = ccfg;
% cfg.run = 1;
% cfg.datafile = 'test_lspionline';
% cfg.maxtime  = 60*5;                % five minutes
% cfg.trialtime = 1.5;
% cfg.dupd = 0.5;
% cfg.explor = 1;                         % start with this exploration rate
% cfg.explordecay = 0.1^(1/cfg.maxtime);  % so that we have 0.1 at the end of the experiment
% cfg.ddisp = 5;
% cfg.dsave = 30;
% cfg.dstoretheta = 10;               % once every 10 seconds
% lspionline(cfg);
% % Run code below to test execution time statistics
% all(timestat.iter_computeAb + timestat.iter_qsolve == timestat.iter_peval)
% all(timestat.iter_interact + timestat.iter_peval + timestat.iter_convtest == timestat.iter_run)
% sum(timestat.iter_run) == timestat.run
% sum(timestat.iter_run + timestat.iter_stats) == timestat.run_save
% 0 == timestat.init
% trun == timestat.run_save

% % LSPE online
% cfg = ccfg;
% cfg.run = 1;
% cfg.datafile = 'test_lspeonline';
% cfg.alpha = 0.05;
% cfg.maxtime  = 60*2;                % 2 minutes
% cfg.trialtime = 1.5;
% cfg.dupd = 0.5;
% cfg.explor = 1;                         % start with this exploration rate
% cfg.explordecay = 0.1^(1/cfg.maxtime);  % so that we have 0.1 at the end of the experiment
% cfg.ddisp = 5;
% cfg.dsave = 30;
% cfg.dstoretheta = 10;               % once every 10 seconds
% lspeonline(cfg);
% % Run code below to test execution time statistics
% all(timestat.iter_computeAb + timestat.iter_qsolve == timestat.iter_peval)
% all(timestat.iter_interact + timestat.iter_peval + timestat.iter_convtest == timestat.iter_run)
% sum(timestat.iter_run) == timestat.run
% sum(timestat.iter_run + timestat.iter_stats) == timestat.run_save
% 0 == timestat.init
% trun == timestat.run_save


% LSPI h online -- index optim
cfg = ccfg;
cfg.run = 1;
cfg.datafile = 'test_lspihonline_indexoptimized'; rand('twister', 1024);
cfg.maxtime  = 60*5;                % five minutes
cfg.trialtime = 1.5;
cfg.dupd = 0.5;
cfg.explor = 1;                         % start with this exploration rate
cfg.explordecay = 0.1^(1/cfg.maxtime);  % so that we have 0.1 at the end of the experiment
cfg.ddisp = 5;
cfg.dsave = 30;
cfg.dstoretheta = 10;               % once every 10 seconds
lspihonline(cfg);
% Run code below to test execution time statistics
all(timestat.iter_computeAb + timestat.iter_qsolve == timestat.iter_peval)
all(timestat.iter_computeh + timestat.iter_hsolve == timestat.iter_pimpr)
all(timestat.iter_interact + timestat.iter_peval + timestat.iter_pimpr + timestat.iter_convtest == timestat.iter_run)
sum(timestat.iter_run) == timestat.run
sum(timestat.iter_run + timestat.iter_stats) == timestat.run_save
0 == timestat.init
trun == timestat.run_save

% LSPI h online -- no index optim
cfg = ccfg;
cfg.run = 1;
cfg.datafile = 'test_lspihonline_noindexoptimized'; rand('twister', 1024);
cfg.indexoptimized = 0;
cfg.maxtime  = 60*5;                % five minutes
cfg.trialtime = 1.5;
cfg.dupd = 0.5;
cfg.explor = 1;                         % start with this exploration rate
cfg.explordecay = 0.1^(1/cfg.maxtime);  % so that we have 0.1 at the end of the experiment
cfg.ddisp = 5;
cfg.dsave = 30;
cfg.dstoretheta = 10;               % once every 10 seconds
lspihonline(cfg);
% Run code below to test execution time statistics
all(timestat.iter_computeAb + timestat.iter_qsolve == timestat.iter_peval)
all(timestat.iter_computeh + timestat.iter_hsolve == timestat.iter_pimpr)
all(timestat.iter_interact + timestat.iter_peval + timestat.iter_pimpr + timestat.iter_convtest == timestat.iter_run)
sum(timestat.iter_run) == timestat.run
sum(timestat.iter_run + timestat.iter_stats) == timestat.run_save
timestat.precomputehphi + timestat.hsamples == timestat.init
trun == timestat.run_save


