
plottarget = 'latex';


switch plottarget,
    case 'beamer',
        % beamer

        % run from source directory!

        % Policy plots for the same act quant and rew fun as fuzzy Q-iteration -- bad varying damping
        % policy
        nav_plot('rbfh datafile=nav_ct_rbfqi interph=0 plottarget=beamer savefig=ct_rbf_badh')
        nav_plot('rbfh datafile=nav_2h_rbfqi interph=0 plottarget=beamer savefig=2h_rbf_badh')

        % Constant damping
        nav_plot('rbfh datafile=nav_ct_rbfqi_u5lev_qrew interph=1 plottarget=beamer savefig=ct_rbf_h')
        nav_plot('policy datafile=navdata_ct_eps1e7_serial interph=1 plottarget=beamer savefig=ct_fuzzy_h')

        nav_trajset('algorithm=rbfqi datafile=nav_ct_rbfqi_u5lev_qrew replaymodelfile=navdata_ct_eps1e7_serial interph=1 plottarget=beamer savefig=ct_rbf_traj')
        nav_trajset('algorithm=fuzzyqi datafile=navdata_ct_eps1e7_serial interph=1 plottarget=beamer savefig=ct_fuzzy_traj')

        % Variable damping
        nav_plot('rbfh datafile=nav_2h_rbfqi_u5lev_qrew interph=0 plottarget=beamer savefig=2h_rbf_h')
        nav_plot('policy datafile=navdata_2h_eps1e2_serial interph=1 plottarget=beamer savefig=2h_fuzzy_h')

        nav_trajset('algorithm=rbfqi datafile=nav_2h_rbfqi_u5lev_qrew replaymodelfile=navdata_2h_eps1e2_serial interph=0 plottarget=beamer savefig=2h_rbf_traj')
        nav_trajset('algorithm=fuzzyqi datafile=navdata_2h_eps1e2_serial interph=1 plottarget=beamer savefig=2h_fuzzy_traj')

    case 'latex',

        savedir = 'D:\Work\tex\papers\alamas07\imgrc\';
        
        % Constant damping
        nav_plot(['rbfh datafile=nav_ct_rbfqi_u5lev_qrew interph=1 plottarget=latex savefig=ct_rbf_h savedir=' savedir])
%         nav_plot(['policy datafile=navdata_ct_eps1e7_serial interph=1 plottarget=latex savefig=ct_fuzzy_h savedir=' savedir])

        nav_trajset(['algorithm=rbfqi datafile=nav_ct_rbfqi_u5lev_qrew replaymodelfile=navdata_ct_eps1e7_serial interph=1 plottarget=latex savefig=ct_rbf_traj savedir=' savedir])
%         nav_trajset(['algorithm=fuzzyqi datafile=navdata_ct_eps1e7_serial interph=1 plottarget=latex savefig=ct_fuzzy_traj savedir=' savedir])

%         % Variable damping
%         nav_plot(['rbfh datafile=nav_2h_rbfqi_u5lev_qrew interph=0 plottarget=latex savefig=2h_rbf_h savedir=' savedir])
%         nav_plot(['policy datafile=navdata_2h_eps1e2_serial interph=1 plottarget=latex savefig=2h_fuzzy_h savedir=' savedir])
% 
%         nav_trajset(['algorithm=rbfqi datafile=nav_2h_rbfqi_u5lev_qrew replaymodelfile=navdata_2h_eps1e2_serial interph=0 plottarget=latex savefig=2h_rbf_traj savedir=' savedir])
%         nav_trajset(['algorithm=fuzzyqi datafile=navdata_2h_eps1e2_serial interph=1 plottarget=latex savefig=2h_fuzzy_traj savedir=' savedir])

end;
