close all;  clear all;
Uval = 2;
Uvals = '_U2';
ccfg = ip_common_config(Uval);

mfilename = ['iponl']; % Ts=0.025 maxstep=160 gamma=0.98
%% IP online tests for a set of n, K=5
narray = [600:300:4500 6000 7500];
K=16;
testParamNames = [Uvals '_K=16'];

for n=narray,
    %online OPD
    cfg = ccfg;
    cfg.planalg = 'opd';            % variant: optimistic planning for deterministic systems
    cfg.planparams.n = floor(n/size(cfg.planparams.U,2));         % budget of expansions at each step
    cfg.datafile = ['iponl_opd' testParamNames '_nsim=' num2str(n)];
    cfg.run = 1;
    genmpc(cfg);              

    %online OKP exploiting redundancy
    cfg = ccfg;
    cfg.planalg = 'okp';            % variant: optimistic planning for deterministic systems
    cfg.planparams.n = floor(n/K/size(cfg.planparams.U,2));         % budget of expansions at each step
    cfg.planparams.K = K;
    cfg.planparams.epsil = 10^(-10);
    cfg.planparams.exploitredundancy = true;
    cfg.datafile = ['iponl_okp' testParamNames '_nsim=' num2str(n)];   
    cfg.run = 1;
    genmpc(cfg);      

    %online OKP exploiting redundancy
    cfg = ccfg;
    cfg.planalg = 'okp';            % variant: optimistic planning for deterministic systems
    cfg.planparams.nsim = n;       % budget of expansions *3 since there are 3 discrete actions
    cfg.planparams.K = K;
    cfg.planparams.epsil = 10^(-10);
    cfg.planparams.exploitredundancy = true;
    cfg.datafile = ['iponl_okp_eqTree' testParamNames '_nsim=' num2str(n)];   
     cfg.run = 1;
    genmpc(cfg);       
end;


%% IP online tests for a set of K, n=640
nsim = 640 ; %n/K should be integer
%online OPD
cfg = ccfg;
cfg.planalg = 'opd';            % variant: optimistic planning for deterministic systems
cfg.planparams.n = n;         % budget of expansions at each step
cfg.datafile = ['iponl_opd_n=' num2str(n)];
cfg.run = 1;
genmpc(cfg);               

Karray = [1 2 4 5 8 10 16 20 32];
for K=Karray,    
    %online OKP exploiting redundancy
    cfg = ccfg;
    cfg.planalg = 'okp';            % variant: optimistic planning for deterministic systems
    cfg.planparams.n = n/K;         % budget of expansions at each step
    cfg.planparams.K = K;
    cfg.planparams.epsil = 10^(-10);
    cfg.planparams.exploitredundancy = true;
    cfg.datafile = ['iponl_okp_n=' num2str(n) 'K=' num2str(K)];   
    cfg.run = 1;
    genmpc(cfg);      

    %online OKP exploiting redundancy
    cfg = ccfg;
    cfg.planalg = 'okp';            % variant: optimistic planning for deterministic systems
    cfg.planparams.nsim = n;       % budget of expansions *3 since there are 3 discrete actions
    cfg.planparams.K = K;
    cfg.planparams.epsil = 10^(-10);
    cfg.planparams.exploitredundancy = true;
    cfg.datafile = ['iponl_okp_eqTree_n=' num2str(n) 'K=' num2str(K)];   
    cfg.run = 1;
    genmpc(cfg);       
end;
